/*phK@\*/
/*{^wύX*/

#include<htc.h>
#include<stdlib.h>
 
__CONFIG(FOSC_HS & WDTE_OFF & PWRTE_ON & BOREN_OFF & LVP_OFF &DEBUG_OFF & CP_OFF);
#define _XTAL_FREQ	10000000

#define SW0 		RB0		//XCb`0
#define SW1			RB1		//XCb`P
#define KEY_MON		RB2		//PFL[j^[I@OFL[j^[It
#define BZ_SW		RB3		//OFuU[I@PFuU[It
#define BZ_OUT		RB5		//OSCMo
#define M1 			RC0		//`l1
#define M2			RC1		//`l2
#define M3 			RC2		//`l3
#define M4 			RC3		//`l4
#define M5 			RC4		//`l5
#define M6 			RC5		//`l6
#define	LCD_DDR		TRISD	//
#define	LCD_port	PORTD   //
#define	LCD_RS		RD4     //
#define	LCD_E		RD5     //
#define LCD_K		RD6		//LEDXCb`

static long counter;
static unsigned char jconv;
static unsigned char key_speed_set=9;
static int v;
static int w;

/* LCD 4rbg ------*/
void LCD_out4( unsigned char data )
{
	unsigned char	tmp1, tmp2;
	LCD_E = 1;					/* E MZbg */
	tmp1 = LCD_port &0xf0;		/* RS Mi[ */
	tmp2 = (data >>4) &0x0f;	/*  4bit ݒ */
	LCD_port = tmp1 | tmp2;		/* RS+datao */
	__delay_us(400);
	LCD_E = 0;
	__delay_us(400);	
	LCD_E = 1;					/* E MZbg */
	tmp1 = LCD_port &0xf0;		/* RS Mi[ */
	tmp2 = data &0x0f;			/*  4bit ݒ */
	LCD_port = tmp1 | tmp2;		/* RS+datao */
  	__delay_us(400);	
	LCD_E = 0;
  	__delay_us(400);	

}

/* LCD 8rbg*/
static	void _LCD_out8( unsigned char data )
{
	__delay_us(400);	
    LCD_RS = 0;						/* @\ݒ*/
	LCD_E = 1;						/* E MZbg */
	LCD_port = data;				/* ް */
 	__delay_us(400);	
	LCD_E = 0;
 	__delay_us(400);	
}

/* LCD */
void LCD_init()
{
	LCD_DDR = 0xb00;				/* Port D o͐ݒ */
	__delay_ms(15);
	_LCD_out8( 0x23 );				/* @\ݒ 1 */
	__delay_ms(10);
	_LCD_out8( 0x23 );				/* @\ݒ 2 */
	__delay_ms(2);
	_LCD_out8( 0x23 );				/* @\ݒ 3 */
	__delay_ms(1);	
	_LCD_out8( 0x22 );				/* @\ݒ */
	__delay_ms(1);	
	LCD_RS = 0;						/* @\ݒ */
	LCD_out4( 0x28 );				/* @\ݒ */
  	__delay_ms(1);		
	LCD_RS = 0;
	LCD_out4( 0x0e );				/* fBXvCEIAJ[\EI */
	__delay_ms(1);	
	LCD_RS = 0;
	LCD_out4( 0x06 );				/* Ӱ */
	__delay_ms(1);	
	LCD_RS = 0;
	LCD_out4( 0x01 );				/* ިڲر */
 	__delay_ms(2);
}

/* LCD Ps\*/
void LCD_disp( unsigned char *str, int line )
{
	unsigned char	*ad;
	int	i;

	LCD_RS = 0;						/* @\ݒ */
	if( line==1 ) LCD_out4( 0x80 );	/*1s  */
	else LCD_out4( 0xc0 );			/* 2s  */
	ad = str;
	for( i=0; i<16; i++ ){			/* o͕ */
		if( *ad == 0 ) return;		/* IȂreturn*/
		LCD_RS = 1;			        /* ްӰސݒ */
		__delay_us(40);
		LCD_out4( *ad );
		__delay_us(60);
		LCD_RS = 0;
		ad++;
	}
}

/* LCD\ʒuw(s, ) */
void LCD_locate( int line, int col )
{
	unsigned char	dat;

	if( line ==1 ) dat = (unsigned char)col + 0x80;
	if( line >=2 ) dat = (unsigned char)col + 0xc0;
	LCD_RS = 0;						/* set function */
	LCD_out4( dat );
}

/* LCD1\*/
void LCD_char( unsigned char dat )
{
	LCD_RS = 1;						/* set data mode */
	__delay_us(40);	
	LCD_out4( dat );
	__delay_us(60);	
	LCD_RS = 0;
}

/* LCD֕f[^HEXQ\*/
void LCD_hex( unsigned char dat )
{
	unsigned char	hex;

	hex = ( (dat>>4) &0x0f) + 0x30;
	if( hex >0x39 ) hex += 0x07;
	LCD_char( hex );
	hex = ( dat &0x0f) + 0x30;
	if( hex >0x39 ) hex += 0x07;
	LCD_char( hex );
}


/*LCD֐lf[^\*/
void LCD_dataout( unsigned long data )

{ 
    unsigned char temp;
    char strtemp[ 10 ];            
    int i, k;
    i=0;
    do {
        temp = data % 10;
        strtemp[i++] = temp + '0';
    } while (( data /= 10 ) != 0); 
    i--; 
    for( k=i; k>=0; k-- ) {
        LCD_char( strtemp[k]);
    }
}

/********荞ݏ*****************************/
static void interrupt isr(void)
{
	T0IF=0;
	INTF=0;
	counter++;		
		if (counter>20000){
			counter=0;
			TMR0=0;
			LCD_K=0;
			SLEEP();
			LCD_K=1;
	}
}

void msec_timer(int msec)
{
	int counter;
	for (counter=0;counter<msec;counter++){
		__delay_ms(1);
	}
}

/**************̓R[hϊ*******************/
unsigned char decode_e(unsigned int data)
{
	unsigned char disp_data;

		disp_data=0x5f;

		if(data==0x0d){			
			disp_data=0x41;		//A
		}
		if(data==0x57){
			disp_data=0x42;		//B
		}
		if(data==0x77){
			disp_data=0x43;		//C
		}
		if(data==0x17){
			disp_data=0x44;		//D
		}		
		if(data==0x01){
			disp_data=0x45;		//E
		}
		if(data==0x75){
			disp_data=0x46;		//F
		}
		if(data==0x1f){
			disp_data=0x47;		//G
		}
		if(data==0x55){
			disp_data=0x48;		//H
		}
		if(data==0x05){
			disp_data=0x49;		//I
		}
		if(data==0xfd){
			disp_data=0x4a;		//J
		}
		if(data==0x37){
			disp_data=0x4b;		//K
		}
		if(data==0x5d){
			disp_data=0x4c;		//L
		}
		if(data==0x0f){
			disp_data=0x4d;		//M
		}
		if(data==0x07){
			disp_data=0x4e;		//N
		}
		if(data==0x3f){
			disp_data=0x4f;		//O
		}
		if(data==0x7d){
			disp_data=0x50;		//P
		}
		if(data==0xdf){
			disp_data=0x51;		//Q
		}
		if(data==0x1d){
			disp_data=0x52;		//R
		}
		if(data==0x15){
			disp_data=0x53;		//S
		}
		if(data==0x03){
			disp_data=0x54;		//T
		}
		if(data==0x35){
			disp_data=0x55;		//U
		}
		if(data==0xd5){
			disp_data=0x56;		//V
		}
		if(data==0x3d){
			disp_data=0x57;		//W
		}
		if(data==0xd7){
			disp_data=0x58;		//X
		}
		if(data==0xf7){
			disp_data=0x59;		//Y
		}
		if(data==0x5f){
			disp_data=0x5a;		//Z
		}
		if(data==0x01d1){
			disp_data=0x2e;		//.
		}
		if(data==0x035f){
			disp_data=0x2c;		//,
		}
		if(data==0x057f){
			disp_data=0x3b;		//;
		}
		if(data==0x07fd){
			disp_data=0x27;		//'
		}
		if(data==0x0d57){
			disp_data=0x2d;		//-
		}
		if(data==0x01f7){
			disp_data=0x28;		//(
		}
		if(data==0x0df7){
			disp_data=0x29;		//)
		}
		if(data==0x01d7){
			disp_data=0x2f;		///
		}
		if(data==0x01dd){
			disp_data=0x2b;		//+
		}
		if(data==0x075d){
			disp_data=0x22;		//"
		}
		if(data==0x077d){
			disp_data=0x40;		//@
		}

	return disp_data;
}

/*************R[h_f[^********************/
unsigned int ecode_gene(void)
{
	unsigned int e_code;
	unsigned char data;
	data=(rand()/762)+1;		//682=32767/43	
	e_code=0x0000;
	while(e_code==0x0000){	
		if(data==1){			
			e_code=0x0d;		//A
		}
		if(data==2){
			e_code=0x57;		//B
		}
		if(data==3){
			e_code=0x77;		//C
		}
		if(data==4){
			e_code=0x17;		//D
		}		
		if(data==5){
			e_code=0x01;		//E
		}
		if(data==6){
			e_code=0x75;		//F
		}
		if(data==7){
			e_code=0x1f;		//G
		}
		if(data==8){
			e_code=0x55;		//H
		}
		if(data==9){
			e_code=0x05;		//I
		}
		if(data==10){
			e_code=0xfd;		//J
		}
		if(data==11){
			e_code=0x37;		//K
		}
		if(data==12){
			e_code=0x5d;		//L
		}
		if(data==13){
			e_code=0x0f;		//M
		}
		if(data==14){
			e_code=0x07;		//N
		}
		if(data==15){
			e_code=0x3f;		//O
		}
		if(data==16){
			e_code=0x7d;		//P
		}
		if(data==17){
			e_code=0xdf;		//Q
		}
		if(data==18){
			e_code=0x1d;		//R
		}
		if(data==19){
			e_code=0x15;		//S
		}
		if(data==20){
			e_code=0x03;		//T
		}
		if(data==21){
			e_code=0x35;		//U
		}
		if(data==22){
			e_code=0xd5;		//V
		}
		if(data==23){
			e_code=0x3d;		//W
		}
		if(data==24){
			e_code=0xd7;		//X
		}
		if(data==25){
			e_code=0xf7;		//Y
		}
		if(data==26){
			e_code=0x5f;		//Z
		}
		if(data==27){
			e_code=0x01d1;		//.
		}
		if(data==28){
			e_code=0x035f;		//,
		}
		if(data==29){
			e_code=0x057f;		//:
		}
		if(data==30){
			e_code=0x0d57;		//-
		}
		if(data==31){
			e_code=0x01d7;		///
		}
		if(data==32){
			e_code=0x077d;		//@
		}
		if(data==33){			//0
			e_code=0x03ff;
		}
		if(data==34){			//1
			e_code=0x03fd;
		}
		if(data==35){			//2
			e_code=0x03f5;
		}		
		if(data==36){			//3
			e_code=0x03d5;
		}
		if(data==37){			//4
			e_code=0x0355;
		}
		if(data==38){
			e_code=0x0155;		//5
		}
		if(data==39){
			e_code=0x0157;		//6
		}
		if(data==40){
			e_code=0x015f;		//7
		}
		if(data==41){
			e_code=0x017f;		//8
		}
		if(data==42){
			e_code=0x01ff;		//9
		}
		if(data==43){
			e_code=0x05f5;		//?
		}
	}
	return e_code;
}


/**************̓R[hϊEa*******************/
unsigned char decode_j(unsigned int data)
{
	unsigned char disp_data;
		disp_data=0x5f;
		if(data==0x03df){			
			disp_data=0xb1;		//A
		}
		if(data==0x000d){
			disp_data=0xb2;		//C
		}
		if(data==0x0035){
			disp_data=0xb3;		//E
		}
		if(data==0x03f7){
			disp_data=0xb4;		//G
		}		
		if(data==0x015d){
			disp_data=0xb5;		//I
		}
		if(data==0x005d){
			disp_data=0xb6;		//J
		}
		if(data==0x0177){
			disp_data=0xb7;		//L
		}
		if(data==0x00d5){
			disp_data=0xb8;		//N
		}
		if(data==0x00f7){
			disp_data=0xb9;		//P
		}
		if(data==0x00ff){
			disp_data=0xba;		//R
		}
		if(data==0x0377){
			disp_data=0xbb;		//T
		}
		if(data==0x01df){
			disp_data=0xbc;		//V
		}
		if(data==0x037f){
			disp_data=0xbd;		//X
		}
		if(data==0x01fd){
			disp_data=0xbe;		//Z
		}
		if(data==0x007f){
			disp_data=0xbf;		//
		}
		if(data==0x0007){
			disp_data=0xc0;		//^
		}
		if(data==0x0075){
			disp_data=0xc1;		//`
		}
		if(data==0x007d){
			disp_data=0xc2;		//c
		}
		if(data==0x03dd){
			disp_data=0xc3;		//e
		}
		if(data==0x0175){
			disp_data=0xc4;		//g
		}
		if(data==0x001d){
			disp_data=0xc5;		//i
		}
		if(data==0x0077){
			disp_data=0xc6;		//
		}
		if(data==0x0055){
			disp_data=0xc7;		//k
		}
		if(data==0x00df){
			disp_data=0xc8;		//
		}
		if(data==0x00f5){
			disp_data=0xc9;		//m
		}
		if(data==0x0057){
			disp_data=0xca;		//n
		}
		if(data==0x035f){			
			disp_data=0xcb;		//q
		}
		if(data==0x005f){
			disp_data=0xcc;		//t
		}
		if(data==0x0001){
			disp_data=0xcd;		//w
		}
		if(data==0x0017){
			disp_data=0xce;		//z
		}		
		if(data==0x00d7){
			disp_data=0xcf;		//}
		}
		if(data==0x0375){
			disp_data=0xd0;		//~
		}
		if(data==0x0003){
			disp_data=0xd1;		//
		}
		if(data==0x00357){
			disp_data=0xd2;		//
		}
		if(data==0x01d7){
			disp_data=0xd3;		//
		}
		if(data==0x003d){
			disp_data=0xd4;		//
		}
		if(data==0x03d7){
			disp_data=0xd5;		//
		}
		if(data==0x000f){
			disp_data=0xd6;		//
		}
		if(data==0x0015){
			disp_data=0xd7;		//
		}
		if(data==0x001f){
			disp_data=0xd8;		//
		}
		if(data==0x01f7){
			disp_data=0xd9;		//
		}
		if(data==0x003f){
			disp_data=0xda;		//
		}
		if(data==0x00dd){
			disp_data=0xdb;		//
		}
		if(data==0x035d){
			disp_data=0x5f;		//
		}
		if(data==0x017d){
			disp_data=0x5f;		//
		}
		if(data==0x00fd){
			disp_data=0xa6;		//
		}
		if(data==0x0037){
			disp_data=0xdc;		//
		}
		if(data==0x01dd){
			disp_data=0xdd;		//
		}
		if(data==0x0005){
			disp_data=0xde;		//J
		}
		if(data==0x01f5){
			disp_data=0xdf;		//K
		}
		if(data==0x037d){
			disp_data=0xb0;		//[
		}
		if(data==0x0d00){
			disp_data=0xa4;		//A
		}
		if(data==0x0df7){
			disp_data=0x28;		//(
		}
		if(data==0x075d){
			disp_data=0x29;		//)
		}
		return disp_data;
}

/*************aR[h_f[^********************/

unsigned int jcode_gene(void)
{
	unsigned int j_code;
	unsigned char data;
	data=(rand()/630)+1;		//630=32767/52
	j_code=0x0000;
	while(j_code==0x0000){
		if(data==1){			
			j_code=0x03df;		//A
		}
		if(data==2){
			j_code=0x000d;		//C
		}
		if(data==3){
			j_code=0x0035;		//E
		}
		if(data==4){
			j_code=0x03f7;		//G
		}		
		if(data==5){
			j_code=0x015d;		//I
		}
		if(data==6){
			j_code=0x005d;		//J
		}
		if(data==7){
			j_code=0x0177;		//L
		}
		if(data==8){
			j_code=0x00d5;		//N
		}
		if(data==9){
			j_code=0x00f7;		//P
		}
		if(data==10){
			j_code=0x00ff;		//R
		}
		if(data==11){
			j_code=0x0377;		//T
		}
		if(data==12){
			j_code=0x01df;		//V
		}
		if(data==13){
			j_code=0x037f;		//X
		}
		if(data==14){
			j_code=0x01fd;		//Z
		}
		if(data==15){
			j_code=0x007f;		//
		}
		if(data==16){
			j_code=0x0007;		//^
		}
		if(data==17){
			j_code=0x0075;		//`
		}
		if(data==18){
			j_code=0x007d;		//c
		}
		if(data==19){
			j_code=0x03dd;		//e
		}
		if(data==20){
			j_code=0x0175;		//g
		}
		if(data==21){
			j_code=0x001d;		//i
		}
		if(data==22){
			j_code=0x0077;		//
		}
		if(data==23){
			j_code=0x0055;		//k
		}
		if(data==24){
			j_code=0x00df;		//
		}
		if(data==25){
			j_code=0x00f5;		//m
		}
		if(data==26){
			j_code=0x0057;		//n
		}
		if(data==27){			
			j_code=0x035f;		//q
		}
		if(data==28){
			j_code=0x005f;		//t
		}
		if(data==29){
			j_code=0x0001;		//w
		}
		if(data==30){
			j_code=0x0017;		//z
		}		
		if(data==31){
			j_code=0x00d7;		//}
		}
		if(data==32){
			j_code=0x0375;		//~
		}
		if(data==33){
			j_code=0x0003;		//
		}
		if(data==34){
			j_code=0x00357;		//
		}
		if(data==35){
			j_code=0x01d7;		//
		}
		if(data==36){
			j_code=0x003d;		//
		}
		if(data==37){
			j_code=0x03d7;		//
		}
		if(data==38){
			j_code=0x000f;		//
		}
		if(data==39){
			j_code=0x0015;		//
		}
		if(data==40){
			j_code=0x001f;		//
		}
		if(data==41){
			j_code=0x01f7;		//
		}
		if(data==42){
			j_code=0x003f;		//
		}
		if(data==43){
			j_code=0x00dd;		//
		}
		if(data==44){
			j_code=0x0037;		//
		}
		if(data==45){
			j_code=0x00fd;		//
		}
		if(data==46){
			j_code=0x01dd;		//
		}
		if(data==47){
			j_code=0x0005;		//J
		}
		if(data==48){
			j_code=0x01f5;		//K
		}
		if(data==49){
			j_code=0x037d;		//[
		}
		if(data==50){
			j_code=0x0d00;		//A
		}
		if(data==51){
			j_code=0x0df7;		//(
		}
		if(data==52){
			j_code=0x075d;		//)
		}
	}
	return j_code;
}

/**************̓R[hϊE*******************/
unsigned char decode(unsigned int data)
{
	unsigned char disp_data;
	unsigned int c_data;

		c_data=data;
		disp_data=0x5f;

		if(data==0x02|data==0x00){	//" "
			disp_data=0xfe;
		}
		if(data==0x03ff){		//0
			disp_data=0x30;
		}
		if(data==0x03fd){		//1
			disp_data=0x31;
		}
		if(data==0x03f5){		//2
			disp_data=0x32;
		}		
		if(data==0x03d5){		//3
			disp_data=0x33;
		}
		if(data==0x0355){		//4
			disp_data=0x34;
		}
		if(data==0x0155){
			disp_data=0x35;		//5
		}
		if(data==0x0157){
			disp_data=0x36;		//6
		}
		if(data==0x015f){
			disp_data=0x37;		//7
		}
		if(data==0x017f){
			disp_data=0x38;		//8
		}
		if(data==0x01ff){
			disp_data=0x39;		//9
		}
		if(data==0x05f5){
			disp_data=0x3f;		//?
		}

		if(disp_data==0x5f){
			if(jconv==1){
				disp_data=decode_j(c_data);
			}
			else{
				disp_data=decode_e(c_data);
			}
		}
	return disp_data;
}

void TIMER_dot(void){
	BZ_SW=1;
	for(v=0;v<key_speed_set;v++){
		BZ_OUT=1;
		__delay_us(800);
		BZ_OUT=0;
		__delay_us(800);
	}
	BZ_SW=0;
}

void TIMER_mark(void){
	BZ_SW=1;
	for(v=0;v<key_speed_set*3;v++){
		BZ_OUT=1;
		__delay_us(800);
		BZ_OUT=0;
		__delay_us(800);
	}
	BZ_SW=0;
}

void SPACE_dot(unsigned int data){
	for(w=0;w<data;w++){
		for(v=0;v<key_speed_set;v++){
			__delay_us(1600);
		}
	}
}

main(){
	int s;
	int t;
	int u;
	int key_st;
	unsigned char mch;
	unsigned int m_buf[16]={0x0000};
	unsigned int chr_buf=0x0000;
	unsigned int code_buf=0x0000;
	unsigned char c_sw=0;			//J[\ʒuXCb`
	unsigned char m_address=0x00;
	unsigned char eeprom_buf=0x00;
	unsigned int chr_buf1;
	unsigned int chr_buf2;
	unsigned char func_m=0;
	unsigned char m_rept=0;			//M3:JԂXCb`
	unsigned char key_speed=1;		//M4:L[CCOx

	unsigned char train=0;			//M5:K[h@0FM@@1FM
	unsigned char disp_chr;
	unsigned char disp_degit=0;
	unsigned char disp_buf[16];
	unsigned char disp_clr[]="                ";
	unsigned char space_disp=0;
	unsigned char key=0;
	unsigned char mr=0;
	unsigned char mw=0;
	unsigned char r_buf;
	unsigned char key_p=0;

	TRISA=0b11111111;
	TRISB=0b00100011;
	TRISC=0b00111111;
	PORTD=0b01000000;
	KEY_MON=0;
	BZ_SW=0;
	jconv=0;

	T0CS=0;
	PSA=0;
	PS0=1;
	PS1=1;
	PS2=1;

	LCD_init();
	__delay_ms(5);
	LCD_K=1;
	LCD_locate(1,0);
	LCD_disp(" PADDLE TRAINER ",1);
	msec_timer(1000);

	T0IF=0;					//荞݃tbONA
	INTF=0;
	TMR0=0;					//^C}[0NA		
	GIE=1;	

	srand(0);

/*****@\ݒ菉****/

	jconv=eeprom_read(241);				//M1
	if(jconv>0){
		jconv=1;
	}
	train=eeprom_read(242);				//M2
	if(train>0){
		train=1;
	}
	m_rept=eeprom_read(243);			//M3
	if(m_rept>0){
		m_rept=1;
	}
	key_speed=eeprom_read(244);			//M4
	if(key_speed>9){
		key_speed=1;
	}
	key_p=eeprom_read(245);				//M5
		if(key_p>0){
		key_p=1;
	}

BIGIN:
	LCD_out4( 0x01 );				/* ިڲر */	
	__delay_ms(1);
	LCD_out4( 0x0c );				//j[\@J[\
	__delay_ms(1);
	disp_degit=0;
	c_sw=0;

	LCD_disp(" M1 M2 M3 M4 M5 ",1);
	
	if(jconv==1){	//EEPROML^l̕\  M1
		LCD_locate(2,1);
		LCD_char(0x4a);
	}
	else{
		LCD_locate(2,1);
		LCD_char(0x45);
	}

	if(train==1){				//M2
		LCD_locate(2,4);
		LCD_char(0x53);
	}
	else{
		LCD_locate(2,4);
		LCD_char(0x52);
	}

	if(m_rept ==1){				//M3
		LCD_locate(2,7);
		LCD_char(0x52);
		LCD_char(0xfe);
	}
	else{
		LCD_locate(2,7);
		LCD_char(0x4e);
		LCD_char(0x52);
	}

	LCD_locate(2,10);			//M4
	LCD_dataout(key_speed);
		
	if(key_p==1){				//M5
		LCD_locate(2,13);
		LCD_char(0x4B);
		LCD_locate(2,14);
		LCD_char(0x41);
	}
	else{
		LCD_locate(2,13);
		LCD_char(0x4B);
		LCD_locate(2,14);
		LCD_char(0x42);
	}

	while(M6==0);

	while(1){
		msec_timer(50);
		if(M1==0){
			func_m=1;
			if(jconv==0){
				jconv=1;
				LCD_locate(2,1);
				LCD_char(0x4a);
			}
			else{
				jconv=0;
				LCD_locate(2,1);
				LCD_char(0x45);
			}
			while(M1==0);
			msec_timer(50);
		}

		if(M2==0){
			func_m=1;
			if(train==0){
				train=1;					//M
				LCD_locate(2,4);
				LCD_char(0x53);
			}
			else{
				train=0;					//M
				LCD_locate(2,4);
				LCD_char(0x52);	
			}
			while(M2==0);
			msec_timer(50);
		}

		if(M3==0){
			func_m=1;
				if(m_rept==0){
				m_rept=1;

				LCD_locate(2,7);
				LCD_char(0x52);
				LCD_char(0xfe);

			}
			else{
				m_rept=0;																									

				LCD_locate(2,7);
				LCD_char(0x4e);
				LCD_char(0x52);	

			}
			while(M3==0);
			msec_timer(50);
		}
		if(M4==0){
			func_m=1;
			key_speed=key_speed+1;
			if(key_speed>9){
				key_speed=1;
			}
			LCD_locate(2,10);
			LCD_dataout(key_speed);
			while(M4==0);
			msec_timer(50);
		}
key_speed_set=(10-key_speed)*10+15;
		if(M5==0){
			func_m=1;
			if(key_p==1){
				key_p=0;					//KA
				LCD_locate(2,13);
				LCD_char(0x4B);
				LCD_locate(2,14);
				LCD_char(0x42);
			}
			else{
				key_p=1;					//KB
				LCD_locate(2,13);
				LCD_char(0x4B);
				LCD_locate(2,14);
				LCD_char(0x41);
			}
			while(M5==0);
			msec_timer(50);
		}
		if(M6==0){
			break;
		}
	}

	if(func_m==1){	
		eeprom_write(241,jconv);		 //@\ݒKey삠ΐݒύXEEPROM		
		eeprom_write(242,train);
		eeprom_write(243,m_rept);
		eeprom_write(244,key_speed);
		eeprom_write(245,key_p);
		func_m=0;
	}

	while(1){
//		dot=key_speed*2+8;
//		mark=dot*3;			//_L[CCOݒ

		T0IE=1;				//TIMER0荞݋
		INTE=1;				//INT荞݋

/***************X^[g********************************/

		if(train==0){
			LCD_disp("   **HEARING**  ",1);
		}
		else{
			LCD_disp("   **KEYING**   ",1);			
		}
		LCD_disp("Hit F for start ",2);			
		while(M6==0);
		msec_timer(50);
		while(M6==1);					//M6Őݒ胁j[
		s=0;
		while(M6==0){
			msec_timer(1);
			s++;
			if(s>500){
				goto BIGIN;
			}
		}

		for(s=0;s<5;s++){				//Jn
BZ_SW=1;
			msec_timer(50);
BZ_SW=0;
			msec_timer(400);
		}
		LCD_out4( 0x01 );				// ިڲر
		__delay_ms(1);
		LCD_out4( 0x0e );				//J[\I
		__delay_ms(1);
		disp_degit=0;
		mr=0;msec_timer(200);

REPT:
/****************Kpf[^[*****************/

		for(s=0;s<16;s++){
			if(jconv==0){
				m_buf[s]=ecode_gene();
			}
			else{
				m_buf[s]=jcode_gene();
			}
		}

		for(s=0;s>16;s++){					//\obt@NA
			disp_buf[s]=0x00;
		}
		disp_degit=0;

//\CNA
		if(train==0){
			if(c_sw==1){
				LCD_disp(disp_clr,2);
				__delay_ms(1);
				LCD_locate(2,0);
			}			
			else{
				LCD_disp(disp_clr,1);
				__delay_ms(1);		
				LCD_locate(1,0);
			}
		}
		else{
			LCD_out4( 0x01 );			// ިڲر
			__delay_ms(1);
		}

		t=0;
		while(t<16){						//16o
			if(c_sw==0){	
				LCD_locate(1,disp_degit);
			}
			else{
				LCD_locate(2,disp_degit);
			}	
			chr_buf=m_buf[t];	
			disp_chr=decode(chr_buf);		//	M\
			LCD_char(disp_chr);				//
			r_buf=disp_chr;

			s=0;	
			if(train==0){
				while(s<16){
					code_buf=0x0000;
					code_buf=chr_buf & 0x0003;
					if(code_buf==0x0000){			//P
						break;
					}
					if(code_buf==0x0001){			//Z_ M[hŉI
TIMER_dot();
					}
					if(code_buf==0x0003){			//_@M[hŉI
TIMER_mark();
					}
					if(code_buf==0x0002){			//ԋʃhbgXy[X(1+2)܂7hbgXy[X
SPACE_dot(4);
					}
SPACE_dot(1);
					chr_buf=chr_buf>>2;
					s++;
				}
			}	


/***********L[ph*****************************/
			if(train==1){
				LCD_locate(2,disp_degit);
				while(SW0==1 && SW1==1){

					s=0;			
					while(M6==0){
						__delay_ms(1);
						s++;
						if(s>500){
							goto BIGIN;
						}
					}
					if(s>0){
						goto REPT;
					}
				}

				if(SW0==0 || SW1==0 ){
					if(key==0){
						key=1;
					disp_degit=0;
					}
					T0IE=0;
					INTE=0;
					TMR0=0;
					counter=0;

					chr_buf=0;
					s=0;

					while(s<8){
						if (SW0==0 || SW1==0){
							if(key_p==1){
								if (SW0==0){
TIMER_mark();
									code_buf=0xc000;			//_
								}
								else{
TIMER_dot();
									code_buf=0x4000;			//Z_
								}
							}
							else{
								if (SW0==1){
TIMER_mark();
									code_buf=0xc000;			//_
								}
								else{
TIMER_dot();
									code_buf=0x4000;			//Z_
								}
							}

SPACE_dot(1);					
							if(s>0){
								chr_buf=chr_buf>>2;
							}
							chr_buf=chr_buf|code_buf;							
							s++;
						}
						else{
							break;
						}
					}

				}
				chr_buf=chr_buf>>(16-s*2);
				disp_chr=decode(chr_buf);
				LCD_char(disp_chr);
			}
	
SPACE_dot(2);					//؂2Xy[Xo͂


/*******ph̓`FbN*****************************************/
			
			if(r_buf!=disp_chr){
				for(s=0;s<5;s++){
					BZ_SW=1;
					__delay_ms(10);
					BZ_SW=0;
					__delay_ms(10);
				}
			}

/**********************************************/
			disp_degit++;
			t++;			

			s=0;			
			while(M6==0){
				__delay_ms(1);
				s++;
				if(s>500){
					goto BIGIN;
				}
			}
			if(s>0){
				goto REPT;
			}
		}

		if(m_rept==1){
			if(train==0){
				if(c_sw==0){
					c_sw=1;
				}
				else{
					c_sw=0;
				}
			}
			else{
				c_sw=0;
			}

			msec_timer(1000);
			goto REPT;
		}
		msec_timer(5000);

	}				//End while
}					//End main
